// Copyright 2018 Alexey Krivonogov. All rights reserved.
// Use of this source code is governed by a MIT license
// that can be found in the LICENSE file.

package compiler

import (
	"math/rand"
	"time"
	"unicode"

	"github.com/gentee/gentee/core"
)

func isBoolResult(cmd core.ICmd) bool {
	return cmd.GetResult().GetName() == `bool`
}

func isIntResult(cmd core.ICmd) bool {
	return cmd.GetResult().GetName() == `int`
}

func isIndexResult(cmd core.ICmd) bool {
	return cmd.GetResult().IndexOf != nil
}

func isCapital(name string) bool {
	for _, ch := range name {
		if !unicode.IsUpper(ch) && ch != '_' && !unicode.IsDigit(ch) {
			return false
		}
	}
	return true
}

func randName() string {
	alpha := []rune("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ")
	length := len(alpha)
	rand.Seed(time.Now().UnixNano())
	b := make([]rune, length)
	for i := range b {
		b[i] = alpha[rand.Intn(length)]
	}
	return string(b)
}
